require_relative 'player'

module StudioGame
  class ClumsyPlayer < Player
    attr_reader :boost_factor

    def initialize (name, health=100, boost_factor=1)
      super(name, health)
      @boost_factor = boost_factor
    end

    def w00t
      @boost_factor.times { super }
    end

    def found_treasure(treasure)
      damaged_treasure = Treasure.new(treasure.name, treasure.points/2.0)
      super(damaged_treasure)
  #    @found_treasures[treasure.name] += (treasure.points/2.0)
  #    puts "#{@name} found a #{treasure.name} worth #{treasure.points} points"
    end

  end

  if __FILE__ == $0
    clumsy = ClumsyPlayer.new("klutz", 100,10)

    hammer = Treasure.new(:hammer, 50)
    clumsy.found_treasure(hammer)
    clumsy.found_treasure(hammer)
    clumsy.found_treasure(hammer)
    clumsy.w00t
    puts "#{clumsy.boost_factor}"
    crowbar = Treasure.new(:crowbar, 400)
    clumsy.found_treasure(crowbar)

    clumsy.each_found_treasure do |treasure|
      puts "#{treasure.points} total #{treasure.name} points"
    end
    puts "#{clumsy.points} grand total points"
  end
end
